
//------------------------------------------------------------------------------
// Programmed by Christof Ermer 
// Tel:01792431170
// Regensburg Mrz 2007
//------------------------------------------------------------------------------

///SYSINFO
#define DATUM		"06.04.2007"
#define FUNKTION	"STEPM = PORT C"
#define UHRZEIT		"12:00"
#define AUTOR		"Chr.Ermer"

#define AVR_ATmega8 //in io.h  elif defined (__AVR_ATmega8__)#  include <avr/iom8.h>

// SCHALTER 
//IN MAIN.H

//WICHTIG!! LSCHEN EINZELENER BITS geht SO: TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2 )))
/*HiSTORY
INT0 ANYCHANGE
Geminsammer Interrrupt mit Port C ABfrage...



// **** Hystorie Hystorie Hystorie Hystorie Hystorie Hystorie ****************
T= in AT8 TICK
FLOAT TIMER UMGESTELLT
nderung der Bezge durch float Grad in Steps Bezogen auf Motor mode udn Step/Rotation
_BV(nummer) == (1<<nummer)
STEPMotor ist an PORT C vorgesehen..
BAUDRATE = 9600 

!! MAKEFILE Optimise normal = 2 !! But !! DANGER EEPROM INTERRUPT ETC..
 !!! SET COPT IN  FUSE BITS TO ENABLE XTAL !!!!!!!!!!!!!
// IF ( ? : );

MERKE delay.h
The maximal possible delay is 768 us / F_CPU in MHz.    	_delay_us(double __us)
The maximal possible delay is 262.14 ms / F_CPU in MHz.		_delay_ms(double __ms)
*/

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

#include <avr\eeprom.h>	

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
#include <compat\deprecated.h>

//#include <avr\twi.h> /* Note [1] */  // NEUE DATEIVERSION_STR BEUNTZEN
//#include <avr\signal.h> //#include <signal.h>

#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "main.h"		//with Hardware assigns
#include "uart.h"
//#include "lcd.h"

#ifndef CTC1
#define CTC1 WGM12              // for compatibility with ATmega
#endif



//Prototypen
int32_t Round(double fIn);

#if TIMER2_USED == 1
void StartTimer2(void);	//0.1 Seconds  interrupt
uint32_t GetTickDifference(uint32_t ullTime);
#endif

#if USE_ERROR_FLAG == 1
uint8_t CheckTimeOut(uint32_t ulTimeNow, uint32_t uiCDiffTime );
#endif

#if USE_TOGGLE_FLAG == 1
void ToggleTEST_BIT(uint8_t ucCnt);
#endif

#if UART_USE_ENABLED == 1
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCRLF(void);
void PrintFloatCRLF(double fVal);
void PrintLongCRLF(int32_t lVal);
void PrintHexCRLF(uint16_t uiVal);
void Print_PStrCRLF(PGM_P pmStr);
void PrintStrCRLF(const uint8_t* pStr);
void FloatToNumStr(double fVal);
void LongToNumStr(int32_t lVal);
void CheckOrder(uint8_t* pcStr);
int CheckTextNumToInt(uint8_t* pcStr, uint32_t *pulVal);
#endif

#if   EEPROM_USED == 1
void LoadParameter(void);
int CheckEEPROM_Valid(void);
void SaveParameter(void);
#endif

#if STEPMOTOR_USED == 1
void Set_StepFRQ(float * pfVal);
void StepFRQ_OnOff(uint8_t uOnOff);
void StepMotorOn(void);
void StepMotorOff(void);
void StepMotorStop(void); 
void Set_StepMotor_Mode(uint8_t ucVal); 
void SetMotorDirection(uint8_t ucVal);
#endif

#if  LCD_4Bit_Module_USED == 1
void WriteLCD(uint8_t bLine, uint8_t *pcStr);
void WriteLCD_P(uint8_t bLine, const char * progmem_s);
#endif


///CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const uint8_t MCA_VERSION[] PROGMEM = VERSION;
#if TEXT_SERVICE_USE_ENABLED == 1
const uint8_t MCA_CRLFSTR[] PROGMEM = {13,10,0};
const uint8_t MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
#endif


#if UART_ERRORMSG == 1
const uint8_t MCA_UARTErr_MSG[] PROGMEM = "UartEr";
#endif




// GLOBALE VARIABLEN 
//MSG
const uint8_t MCA_SPACE_MSG[] PROGMEM	= " ";
const uint8_t MCA_ISTGLEICH_MSG[] PROGMEM	= "=";
const uint8_t MCA_DELIMITER_MSG[] PROGMEM	= ",";
const uint8_t MCA_WRONG_MSG[] PROGMEM	= "WRONG";	
const uint8_t MCA_OK_MSG[] PROGMEM		= "OK";	

const uint8_t MCA_PING_CMD[] PROGMEM = "PING";	 //CONST ARRAY
const uint8_t MCA_PONG_MSG[] PROGMEM	= "PONG";
const uint8_t MCA_VALID_MSG[] PROGMEM	= "Valid";

#if EEPROM_USED == 1
const uint8_t MCA_EEPROM_MSG[] PROGMEM	= "EEPROM";
const uint8_t MCA_SAVE_CMD[] PROGMEM = "Save";	 //CONST ARRAY
const uint8_t MCA_LOAD_CMD[]PROGMEM = "Load"; 
#endif

#if STEPMOTOR_USED == 1
//0010 1000 = 0x28
//0001 0001 = 0x12
//0010 0100 = 0x24
//0001 0010 = 0x12
//const uint8_t MCA_WAVEDRIVE[] PROGMEM = {0x28,0x12,0x24,0x12};	//CONST ARRAY
//FULLSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0011 1001 = 0x39
//0011 0101 = 0x35
//0011 0110 = 0x36
//const uint8_t MCA_FULLSTEPS[] PROGMEM = {0xBA,0xB9,0xB5,0xB6};	//CONST ARRAY
const uint8_t MCA_FULLSTEPS[] PROGMEM = {0x3A,0x39,0x35,0x36};	//CONST ARRAY
//HALFSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0010 1000 = 0x28
//0011 1001 = 0x39
//0001 0001 = 0x11
//0011 0101 = 0x35
//0010 0100 = 0x24
//0011 0110 = 0x36
//0001 0010 = 0x12
const uint8_t MCA_HALFSTEPS[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12};	//CONST ARRAY
//const uint8_t MCA_HALFSTEPS[] PROGMEM = {0xBA,0xA8,0xB9,0x91,0xB5,0xA4,0xB6,0x92};	//CONST ARRAY
//const uint8_t MCA_QUARTERSTEPS[] PROGMEM = {};	//CONST ARRAY
//const uint8_t MCA_EIGHTSTEPS[] PROGMEM = {};	//CONST ARRAY
const uint8_t MCA_SET_HALFSTEPMODE_CMD[] PROGMEM = "HALF";	//HALF STEP
const uint8_t MCA_SET_FULLSTEPMODE_CMD[] PROGMEM = "FULL";	//FULL STEP
const uint8_t MCA_SET_DIRECTION_CMD[] PROGMEM = "DIR";	//SET DIRECTION
const uint8_t MCA_MOTOR_ON_CMD[] PROGMEM = "MO";	 //motor on
const uint8_t MCA_MOPD_CMD[] PROGMEM = "MOPD";	 //MOTOR PULS DIRECTION
const uint8_t MCA_MOTOR_OFF_CMD[] PROGMEM = "MF";	 //motor off
const uint8_t MCA_MOTOR_STOP_CMD[] PROGMEM = "MS";	 //motor stop
const uint8_t MCA_SETFRQ_CMD[] PROGMEM = "SFR";	 //set frequency
const uint8_t MCA_SPR_CMD[] PROGMEM = "SPR";	 //Steps Per Rotaion
const uint8_t MCA_SET_RAMPE_CMD[] PROGMEM = "RAMPE";	 //RAMP RISE ON
#endif






#if UART_USE_ENABLED == 1
volatile uint8_t* gpcRxPars;
static uint8_t gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static uint8_t gcaNumStr[NUMMAX + 1]; //+1 for the 0
static uint8_t gcaStr[STRMAX + 1]; //+1 for the 0
COMMAND_TYPE gsCmd;
#endif


//EEPROM VARIABLEN
//#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
//#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//uint16_t guiEEPDUMMY EEPROM_SECTION = EE_DUMMYLOAD; //avoid using lowest adress.
//ohne Prdefintion
#if EEPROM_USED == 1
uint16_t guiEEPDUMMY EEPROM_SECTION; //avoid using lowest adress.
EEPROM_STR_TYPE gucaEEPStr EEPROM_SECTION;	//String [12], FR "EEPROMVALID"siehe main.H
STEPMPARTYPE gsEEPROMsStMPar EEPROM_SECTION;  //Parameterstruktur
#endif 


#if STEPMOTOR_USED == 1
STEPMPARTYPE gsStMPar;		//SPEICHERT DIE PARAMETER //deklarion in Main.H
uint8_t gucStepPars; //+1 or -1 for the Bitpatternselect
uint8_t gucModePatternModulo; // Modulo selector (HALF/FULLSTEP..)
static PGM_P gpmpaStepPattern;
uint32_t gulMActiveStopTime; //LONG

#endif


#if TIMER2_USED == 1
//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
static uint32_t gulT2_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#endif
# if USE_ERROR_FLAG == 1
uint8_t gbErrorFlag;
#endif
//EEPROM VARIABLEN
//#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
//#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//uint16_t guiEEPDUMMY EEPROM_SECTION = EE_DUMMYLOAD; //avoid using lowest adress.
//ohne Prdefintion
//uint16_t guiEEPDUMMY EEPROM_SECTION; //avoid using lowest adress.
//EEPROM_STR_TYPE gucaEEPStr EEPROM_SECTION;	//String [12], FR "EEPROMVALID"siehe main.H
//STEPMPARTYPE gsEEPROMsStMPar EEPROM_SECTION;  //Parameterstruktur

//FLAG SECTION
//NIE LANGE IN INERRUPTS RUMWURSCHTLN STEIGT SONST AUS
//INTERRUPT
//RCO_B
/*
// ************************	****************************************
volatile SIGNAL(SIG_INTERRUPT0)// signal handler for external interrupt int0
// *******************************************************************
{//OVERFLOW_CNT_ON_INT0_MAC WIRD Freigegeben durch
sei();	//INTERRUPT ENABLE  //cli();
};



//GATE
// ************************	****************************************
volatile SIGNAL(SIG_INTERRUPT1)// signal handler for external interrupt int0
// *******************************************************************
{//GATE_ALL_EVENT_ON_INT1_MAC
sei();	//INTERRUPT ENABLE  //cli();
};
*/

#if TIMER2_USED == 1
// ****************************************************************
volatile  SIGNAL(SIG_OVERFLOW2) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();
//I_SREG automtaic clear by Interrupt and Enabled by RETI
//cbi(TIMSK, TOIE2);
// 16MhZ / 1024 / 256  = 61,03515625 Hz T= 1/f = 0.016384 ms / Interrupt
// 16MhZ / 64 / 256  = 976,5625 HZ    T= 1/f	=   0,001024 ms / Interrupt
// 
gulT2_Ticks++;
ToggleTEST_BIT(1);
/*
if( (++gulT2_Ticks) > (BEFORE_DWORD_LIMIT) ) //0xFFFFFF00 //Um einen Zhlerberlauf zu verhindern !
	{	
	gulT2_Ticks = 0;  //Wegens Ausfallgefahr bei berlauf = MINUS
	};
*/
};
#endif

#if STEPMOTOR_USED  == 1
// ****************************************************************
SIGNAL(SIG_OUTPUT_COMPARE1A)// signal handler
//#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// *******************************************************************
{
//static uint8_t ucBitpattern;
//I_SREG automtaic clear by Interrupt and Enabled by RETI	
sei();	//INTERRUPT ENABLE
if( gsStMPar.ucStepMConditionFlag & STEPM_RUN_FLAG )
	{
#if SM_LINE_FUCNTIONS_ENABLED == 1
	//Long DISTAcNE with multiple roations --> ein Target in einer Bewegungsachse +/- um den Indexpunkt
	if( (gsStMPar.ucSM_PostionFlag & POSITION_STOP_ON_DISTANCE_MODE_FLAG) &&
		(gliLIneTargePoint == gsStMPar.iSM_IndexDifference  )
	)
		{
		StepMotorStop();
		//gsStMPar.ucSM_PostionFlag &= ~POSITION_STOP_ON_DISTANCE_MODE_FLAG;
		return;		
		};
#endif

#if SM_SECTOR_FUNCTIONS_ENABLED == 1	
	//Target ->meint Target in einer Rotation
	if( (gsStMPar.ucSM_PostionFlag & POSITION_STOP_ON_TARGET_MODE_FLAG) &&
		( guiMTargetPoint == gsStMPar.iSM_RotPosition )
	)
		{
		StepMotorStop();
		//gsStMPar.ucSM_PostionFlag &= ~POSITION_STOP_ON_TARGET_MODE_FLAG;
		return;		
		};
#endif	
	//check MOP Count...
	if(	(gsStMPar.ucStepMConditionFlag & STEPM_PULSE_MODE_FLAG) && 
			(gsStMPar.ulMovedSteps >= gsStMPar.ulSM_ToRunCnt )
	)
		{		
		StepMotorStop();	//EVTL. MIT AUTORELEASE_TIMEOUT
		//gsStMPar.ucStepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG;
		return;
		//StepMotorOff();//GEHT NICHT; WEIL ER SONST ZU SCHNELL AUSSCHALTET
		};	

	//Zuerst  Bitmuster whlen, damit Motor immer auf gucStepPars steht.
	if( gsStMPar.ucStepMConditionFlag & STEPM_DIRECTION_FLAG )		
		{//Linksrum Relativ zu Markerpfeil am Rand....
		gucStepPars--;
		}
	else
		{//Rechts
		gucStepPars++;
		};	
	//gucStepPars = ZahlenRing(gucStepPars, gucModePatternModulo);
	//gucStepPars %= ZahlenRing(gucStepPars, gucModePatternModulo);
//PrintFloatCRLF(gucStepPars);	
	//Bitmuster am Schrittmotor ausgeben
	STEPCTRL_PORTX =  //Aktueller Steppars..Enabeln
		((STEPCTRL_PINX) & (~STEPAMP_ALLCTRL_MASK))	| //ODER . ehalte alle anderen Bits	
		(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gucStepPars % gucModePatternModulo) ) ) ); 			 
	gsStMPar.ulMovedSteps++; //Zhle die Pulse.. !!				
//	gulMActiveStopTime = gulT2_Ticks; //Zeigt die Zeit der letzen Aktivitt an


	if(	(gsStMPar.ucStepMConditionFlag & STEPM_RAMPE_FLAG) && //RAMPEnFAHREN Situation
		(gsStMPar.ucStepMConditionFlag & STEPM_START_RAMPE_FLAG)
	)//Frequenz nur setzen, wenn Rampe aktiv
		{
		gsStMPar.fRampeFrq += (float)gsStMPar.ucStepMot_RampRise; // Rampe hochfahren		
		if( gsStMPar.fRampeFrq >= gsStMPar.fStepMot_FRQ )
			{			
			gsStMPar.fRampeFrq = gsStMPar.fStepMot_FRQ;
			gsStMPar.ucStepMConditionFlag &= ~STEPM_START_RAMPE_FLAG;	//RAMPE EREICHT					
			};
		Set_StepFRQ(&gsStMPar.fRampeFrq);
		};	
	//---------------------
	}
else	//gsStMPar.ucStepMConditionFlag & STEPM_ENABLE_FLAG
	{
	StepMotorStop();
	};	
};
#endif




/*
//CCCC
// ****************************************************************
SIGNAL(SIG_OUTPUT_COMPARE1A)// signal handler
//#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// *******************************************************************
{
sei();
};
*/

// **********************************************
int32_t Round(double fIn)
// **********************************************
{
return (int32_t)floor(fIn + 0.5);
};

//EEPROM
#if   EEPROM_USED == 1
// ****************************************************************
void SaveParameter(void)
// ****************************************************************
{
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=0;
strcpy_P(gcaStr, MCA_EEPROM_MSG);
strcat_P(gcaStr, MCA_VALID_MSG);
cli(); // Schalte Interrupts aus !!
//void eeprom_write_word (uint16_t *addr, uint16_t val)
eeprom_busy_wait();
eeprom_write_word( &guiEEPDUMMY, EE_DUMMYLOAD); //IN 0 NIX LADEN
//uiAdr=2;//Next Adress
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((uint8_t*)gcaStr, &gucaEEPStr, sizeof(gucaEEPStr) );
//uiAdr+=uiSize;
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((STEPMPARTYPE*)&gsStMPar, &gsEEPROMsStMPar, sizeof(STEPMPARTYPE));
sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
uart_puts_p( MCA_EEPROM_MSG );
Print_PStrCRLF(MCA_SAVE_CMD);
#endif
};
#endif


#if   EEPROM_USED == 1
//EE
// *******************************************************************
int CheckEEPROM_Valid(void)
// *******************************************************************
{//return 0 = Fehler
uint16_t uiDummy; 
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=2;
//Hilfsweise gcaNumStr.
strcpy_P(gcaNumStr, MCA_EEPROM_MSG);// DAS MUSS DRINSTEHEN
strcat_P(gcaNumStr, MCA_VALID_MSG); // DAS MUSS DRINSTEHEN
cli(); // Schalte Interrupts aus !!
eeprom_busy_wait();
uiDummy = eeprom_read_word(&guiEEPDUMMY); // 1. Dummy read 
//eeprom_read_block( (char*)gcaStr, &gucaEEPStr, (strlen(gcaNumStr) + 1) );
eeprom_busy_wait();
eeprom_read_block( &gcaStr[0], &gucaEEPStr, sizeof(gucaEEPStr) );
sei(); // Schalte Interrupts wieder an !!
*(gcaStr + strlen(gcaNumStr))= 0;	// [12]-1=11	 //Terminiere
if( strncmp(gcaStr ,gcaNumStr,strlen(gcaNumStr)) ) //EEPROMVAILD --> Cmp=0
	{//!=
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_MSG );
	uart_puts_p( MCA_SPACE_MSG );
	Print_PStrCRLF( MCA_WRONG_MSG );
#endif
	//SaveParameter();
	return 0;		
	}
else
	{//OK
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_MSG );
	uart_puts_p( MCA_SPACE_MSG );
	Print_PStrCRLF( MCA_OK_MSG );
#endif
	return 1;
	};
};
#endif

#if   EEPROM_USED == 1
// ****************************************************************
void LoadParameter(void)
// ****************************************************************
{
if( CheckEEPROM_Valid() )
	{
	cli(); // Schalte Interrupts aus !!
//void  eeprom_read_block (void *buf, const void *addr, size_t n)
	eeprom_busy_wait();
	eeprom_read_block((STEPMPARTYPE*)&gsStMPar, &gsEEPROMsStMPar, sizeof(STEPMPARTYPE));
	sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_MSG );
	Print_PStrCRLF( MCA_LOAD_CMD );
#endif
	};
};
#endif 

#if  TIMER2_USED == 1
// *************************************
void StartTimer2(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK = 0;	/* disable timer interrupts */
OCR2 = TCNT2 = gulT2_Ticks = 0;  //Timer MAX = TOP Compare
//ASSR &= ~(_BV(AS2)); //ASS2  CLOCK FREIGABE von QUARZ
//SFIOR |= PSR2; //RESET COUNTER
//8 Bit Timerx00);	//Timer Inhalt
// 16 MHZ  / 64 = 250000
//250000 / 256 = 3906,25  Intterrupts / Sekunde
//(1/3906,25)  = 0,000256 =  Zeit in Sek/ Interrupt
// SYSCLK_256 / 64 =  675 = 0,0014814814814814814814814814814815   mS Interrrupt
//TIMER STARTS with Presscale Select = 64
TIFR = 0;
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_64;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= _BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};
#endif

#if  TIMER2_USED == 1
// ****************************************************************
uint32_t GetTickDifference(uint32_t ullTime)
// ****************************************************************
{
return (gulT2_Ticks - ullTime);
};
#endif



#if USE_TOGGLE_FLAG == 1
// ****************************************************************
void ToggleTEST_BIT(uint8_t ucCnt)
// ****************************************************************
{
uint8_t ucNN;
for(ucNN=0; ucNN < ucCnt; ucNN++)
	{
	SET_TESTBIT_MAC;
	_delay_us(1);
	CLR_TESTBIT_MAC;
	_delay_us(1);
	};
};
#endif



#if UART_USE_ENABLED == 1
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#if UART_ERRORMSG == 1
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCRLF(  MCA_UARTErr_MSG );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif



#if UART_USE_ENABLED == 1
// **********************************************
void FloatToNumStr(double fVal)
// *************
{
sprintf(gcaNumStr,"%.1f", fVal);
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{
sprintf(gcaNumStr,"%ld", lVal);  //Ulong = %ld
};



// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#if UART_USE_ENABLED == 1  //MAKLEFILE ANPASSEN
// *******************************************************************
void PrintCRLF(void)
// *******************************************************************
{
uart_puts_p( MCA_CRLFSTR );
};


// *******************************************************************
void PrintStrCRLF(const uint8_t* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCRLF();
};


// *******************************************************************
void Print_PStrCRLF(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCRLF();
};


// *******************************************************************
void PrintFloatCRLF(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCRLF(gcaNumStr);
};

// *******************************************************************
void PrintLongCRLF(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCRLF(gcaNumStr);
};

#endif

#if  (UART_USE_ENABLED == 1) && (USED_HEX_CONVERSION == 1)
// *******************************************************************
void PrintHexCRLF(uint16_t uiVal)
// *******************************************************************
{
ULongToHexNumStr(uiVal); PrintStrCRLF(gcaNumStr);
};
#endif



#if STEPMOTOR_USED == 1
// *************************************
void Set_StepMotor_Mode(uint8_t ucVal) 
//gsStMPar.ucStepMConditionFlag & STEPM_STEPMODE12_MASK
// *************************************
{ //0 = FULL_STEP 1= HALFSTEP;
//Berechne tatschliche Schritte pro Rotation
gsStMPar.ucSM_Mode = ucVal;
gsStMPar.uiStepsPerRotation = gsStMPar.uiSM_MotorStepsRotationType * ucVal;//wegen:half/full
switch(ucVal)
	{
	case MODE_FULLSTEP :	//*1
		{//FULL 1
		//gsStMPar.ucSM_Mode = MODE_FULLSTEP;
		gpmpaStepPattern = MCA_FULLSTEPS;	//MCA pointer Adr.
		gucModePatternModulo = FULLSTEPMODEPARSMAX;//4
		break;
		};
	case MODE_HALFSTEP :	//*2
		{
		//gsStMPar.ucSM_Mode = MODE_HALFSTEP;
		gpmpaStepPattern = MCA_HALFSTEPS;	//MCA pointer Adr.
		gucModePatternModulo = HALFSTEPMODEPARSMAX;//8 
		break;
		};
	};
};
#endif

#if STEPMOTOR_USED == 1
// *************************************
void SetMotorDirection(uint8_t ucVal)
// *************************************
{//0= Rechts  1=Linksrum
//Nur wenn nicht schon so eingestellt
//Geht nur, weil #define STEPM_DIRECTION_FLAG		0x01= NULL Bit --> Sonst Shift Bit
if( (gsStMPar.ucStepMConditionFlag & STEPM_DIRECTION_FLAG) ^ ucVal )  //EXOR ungleich?
	{
	if(ucVal) //1 == links
		{
		gsStMPar.ucStepMConditionFlag |= STEPM_DIRECTION_FLAG;
		}
	else//dir == 0 == rechts
		{
		gsStMPar.ucStepMConditionFlag &= ~STEPM_DIRECTION_FLAG;
		};
//Falls Motor grad aktiv ist,,halt in an,und ndere die Richtung		
	if( (gsStMPar.ucStepMConditionFlag & STEPM_ENABLE_FLAG)  && 
		(gsStMPar.ucStepMConditionFlag & STEPM_RUN_FLAG ) 
	)
		{
		StepMotorStop();
		gsStMPar.ucStepMConditionFlag |= STEPM_START_RAMPE_FLAG;		
		StepMotorOn();
		};
	};
};
#endif

#if STEPMOTOR_USED == 1
// *************************************
void StepMotorOn(void)
// *************************************
{//CPU_ICTRL_ONOFFLAG steuert ob dauerstrom oder PWM
	//Verriegelung, falls der Motor an den Anschlagschalterns steht, 
	//das er in die falsche Richtung anstartet	
	//0x10 Wert des EXtswitch via INT1 = LINKS
	//define MODE_FULLSTEP 0x00	define MODE_HALFSTEP 0x01
	//1. Warte auf Stop --> Ist der Auftrag erledigt, (verhindert widersprechnede Befehle)
/*
	while( !(gsStMPar.ucSM_PostionFlag & POSITION_STOP_ON_TARGET_OK) )	
		{//Damit der Motor sich beruhigen kann
		wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		};
*/

#if USE_ENDPOSITION_SWITCH_INT0 == 1
//#define SM_DIR_LINKS	1
if( !(gstInt0Key.ucKeyStat & KEYSTAT_RELEASED) && 
	(
	(
	(gstInt0Key.ucKey == KEY_ENDSWITCH_LEFT ) && (gsStMPar.ucStepMConditionFlag & STEPM_DIRECTION_FLAG)
	) || 
	(
	( gstInt0Key.ucKey == KEY_ENDSWITCH_RIGHT )  &&  !(gsStMPar.ucStepMConditionFlag & STEPM_DIRECTION_FLAG)
	)
	)
  )
	{
	return;
	};
#endif

	//2.Warte nach Stop
	while( (gsStMPar.ucStepMConditionFlag & STEPM_STOP_ACTIVE_FLAG) &&
			(GetTickDifference(gulMActiveStopTime) < SM_AFTERSTOPDELAY_TICKS ) //~30ms
		)
		{	
//Damit der Motor sich beruhigen kann
		wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		};
		
	Set_StepMotor_Mode( gsStMPar.ucSM_Mode );		
	//Nur Rampe wenn FRQ > PREDEF_RAMPENSSTARTFRQ
	if(	(gsStMPar.fStepMot_FRQ > PREDEF_RAMPENSSTARTFRQ) && //Also mit RAMPE
		(gsStMPar.ucStepMConditionFlag & STEPM_RAMPE_FLAG) 
	)
		{
		gsStMPar.ucStepMConditionFlag |= STEPM_START_RAMPE_FLAG;  //START !!!! Situation
		gsStMPar.fRampeFrq = PREDEF_RAMPENSSTARTFRQ;
		}
	else//KEINE RAMPE
		{ 
		gsStMPar.fRampeFrq = gsStMPar.fStepMot_FRQ;	//Set Frequenz wie in Struckt. !
		};
	//gsStMPar.ucCPUModeFlag |= CPU_ICTRL_ONOFFLAG;	//ABSICHTSchalte I EIN
	//Activate INT1 IRQ after some Way ( EXT Sensor must be released )
	// VOr Start INT1 blockieren, damit Sensor beim Loslaufen nicht rger macht.
	// LSCHE NUN DIE INT1 BEREITSCHAFT !!
	//Weil der EXT Sensor Taster beim Losfahren prellen kann wird er anfnglich deaktiviert
	// gsStMPar.ulMovedSteps > SENSORDISTANCESTEPS ) ist erforderlich
	//Vorsorglich das Interrupt Flag Register auch  lschen
//	sbi(GIFR, INTF1); //Write a logical one clears the Flag ???( initial ist aber 0 ) !!Vewirrend !!	
//	sbi(GICR, INT1); //Aktiviere EXT INT1  Sensor Interrrupt !!
		//UND NUN GEHTS AN DEN START
//	gsStMPar.ucStepMConditionFlag  &= ~STEPM_PAUSE_FLAG;
	gsStMPar.ulMovedSteps = 0;	//COUNTSZHLER !!!!!!!
	//Lege die letzen Bitts an...
	if( !(gsStMPar.ucStepMConditionFlag & STEPM_ENABLE_FLAG) )
		{		
		STEPCTRL_PORTX =  //Aktueller Stepper..Enabel
			((STEPCTRL_PINX ) & ~STEPAMP_ALLCTRL_MASK)	| //ODER . clear SMbit und erhalte alle anderen Bits	
			(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + gucStepPars) ) );		
		//Unbedingt warten damit Magnetfeld sich aufbauen und fangen kann.
//		ICTRL_HIGH_CURRENT_MAC
		_delay_ms( Motor_START_LAST_BITPATTERN_ON_TIME );	//30ms	
		};	
	//ICTRL_HIGH_CURRENT_MAC
	
	//3.erst dann Starte	
	gsStMPar.ucStepMConditionFlag |= STEPM_ENABLE_FLAG | STEPM_RUN_FLAG;//ENABLE ANZEIGEN (INTERRUPPT)UND SPEICHERN		
	gsStMPar.ucStepMConditionFlag &= ((~STEPM_STOP_ACTIVE_FLAG) & (~STEPM_TIMEOUT_ENABLE_FLAG));	//Lsche Pausebedingung	
	gsStMPar.ucSM_PostionFlag &= ~POSITION_STOP_ON_TARGET_OK;
	Set_StepFRQ(&gsStMPar.fRampeFrq);
	StepFRQ_OnOff(FRQ_ON); 
//	ACTIVE//LED_ON_MAC
};
#endif




#if STEPMOTOR_USED == 1
// *************************************
void StepMotorStop(void)	//hlt mOTOR an, ictrl/pwm,bleibt ENABLE !!
// *************************************
{
StepFRQ_OnOff(FRQ_OFF);	//0
//ENABELD ( STROM AKTIV !!!!)
gulMActiveStopTime = gulT2_Ticks; //Vergleichszeit. z.B. for PWM or Heatprotect (nur ne idee)
//Jetzt mit allen Flags aufrumen
gsStMPar.ucStepMConditionFlag &= ~(STEPM_RUN_FLAG | STEPM_PULSE_MODE_FLAG);
gsStMPar.ucSM_PostionFlag &= ~(POSITION_STOP_ON_DISTANCE_MODE_FLAG | POSITION_STOP_ON_TARGET_MODE_FLAG);
gsStMPar.ucSM_PostionFlag |= POSITION_STOP_ON_TARGET_OK;
//Stelle akutelles Bitmuster ein
/*
STEPCTRL_PORTX =  //Aktueller Steppars..Enabeln
	((STEPCTRL_PINX) & (~STEPAMP_ALLCTRL_MASK))	| //ODER . ehalte alle anderen Bits	
	(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gucStepPars % gucModePatternModulo) ) ) ); 
*/
//MIT BEIDE ENABLES ON
STEPCTRL_PORTX =  //Aktueller Steppars..Enabeln
	((STEPCTRL_PINX) & (~STEPAMP_ALLCTRL_MASK))	| //ODER . ehalte alle anderen Bits	
	(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gucStepPars % gucModePatternModulo) ) ) ) 
	| STEPAMP_ENABLE_MASK; 

gulMActiveStopTime = gulT2_Ticks; //Neu  
gsStMPar.ucStepMConditionFlag |= STEPM_STOP_ACTIVE_FLAG | STEPM_TIMEOUT_ENABLE_FLAG;	//Zeige Stopstatus-ENABLED an
/*
	STEPCTRL_PORTX =  //Aktueller Steppars..Enabeln
		((STEPCTRL_PINX) & (~STEPAMP_ALLCTRL_MASK))	| //ODER . ehalte alle anderen Bits	
		(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gucStepPars % gucModePatternModulo) ) ) ); 	
*/		
//ICTRL_LOW_CURRENT_MAC	//Schaltet Haltestrom an mit aktiven ENABLEleitungen
//ANDERS VERFAHREN; TIMEOUT fr Stromzurckschalten
//1234
#if MSG_STOP_ENABLED == 1
TX_Prefix();Print_PStrCRLF( MCA_STOP_MSG );
#endif
};
#endif


#if STEPMOTOR_USED == 1
// *************************************
void StepMotorOff(void)	//Komplett STOPS AND FREE axis.
// *************************************
{
StepMotorStop();
//ICTRL_OnOff(0);
//PWM_OnOff(0);
//Lsche Stopstatus
STEPCTRL_PORTX = STEPCTRL_PINX & (~STEPAMP_ENABLE_MASK ); // Lsche nur!  Enable Status
//ICTRL_LOW_CURRENT_MAC
gsStMPar.ucStepMConditionFlag &= (
								  (~STEPM_ENABLE_FLAG) & 
								  (~STEPM_STOP_ACTIVE_FLAG) & 
								  (~STEPM_RUN_FLAG) 
								  );
//NUR CONTROLL LIENES; ENABLE ARE ACTIV. //BITS LASSEN; WIE SIE SIND..!!!!
};
#endif




#if STEPMOTOR_USED == 1
// *************************************
void Set_StepFRQ(float * pfVal)
// *************************************
{
unsigned char sreg;
//uint16_t uiOCR1LH_Val;
sreg = SREG;
cli();
//Hz = Counts/Sec
//uint8_t  cSReg;
//cSReg = SREG;  //Save global Interrupt Flag
//Watch WGM13.0 in TCCR1B Waveform
//PRESACLER POSSIBILITY
//16Mhz/256= 62500
//16Mhz/64 = 250000
//16Mhz/1024 = 15625 Counts/Sec  !!!!
// 65536 / 15625 = 4.194304 Sekunden fr vollen Timerlauf 
//= 1/F = 0,2384185791015625 Hz minimal
//#define PULS_PER_SECOND_T1 15625
//#define Time_Per_count_T1 0.000064		//  1/15625
//1.Mgl
//uiOCR1LH_Val = 1.0 / (TIme_Per_count_T1  * ufFrq)  ;
//2.Mgl.
//uiOCR1LH_Val = Round( (PULS_PER_SECOND_T1 * (1.0 / *pfVal) )  );
TCNT1 = 0;  //sicherung gegenen unbeabsichtigten Overrrun
OCR1A = (uint16_t)Round( (PULS_PER_SECOND_T1 * (1.0 / *pfVal) ) );
TCNT1 = 0;
//first HIGH absolut notwenig...
//OCR1AH = (unsigned char)((uiOCR1LH_Val & 0xFF00) >> 8);
//OCR1AL = (unsigned char)(uiOCR1LH_Val & 0x00FF);
SREG = sreg;
sei();
};
#endif

#if STEPMOTOR_USED == 1
// *************************************
void StepFRQ_OnOff(uint8_t uOnOff)
// *************************************
{
//unsigned char sreg;
//sreg = SREG;
//cli()
unsigned char ucSreg;
//uint16_t uiOCR1LH_Val;
ucSreg = SREG;
cli();

TCCR1B = TCCR1B_CLOCKSEL_STOP;	//Stopen, damit keine geschachtelten Interrrupts passieren...
if( uOnOff )  // Im FALLE DAS FRQ = 0 MOTOR STOP !
	{
// 0000 0000
//WGM 11=0	WGM 10=0
	TIMSK &= (~_BV(TICIE1)) & (~_BV(OCIE1A )) & (~_BV(OCIE1B )) & (~_BV(TOIE1 ));
	//cbi(TIMSK, TICIE1);	cbi(TIMSK, OCIE1A);	cbi(TIMSK, OCIE1B);	cbi(TIMSK, TOIE1);
	TIFR &= (~_BV(ICF1 )) & (~_BV(OCF1A )) & (~_BV(OCF1B )) & (~_BV(TOV1 ));
	//cbi(TIFR, ICF1);	cbi(TIFR, OCF1A);	cbi(TIFR, OCF1B);	cbi(TIFR, TOV1);	
	
	
// 0000 1101   OCR1X depended CTC   1024   
//WGM 13=0 //WGM 12=1 //CS12=1 //CS11=0 //CS10=1 
	ICR1 = OCR1B = TCNT1 = 0;/* reset TCNT1 */		/* disable PWM and stuff */
//	Set_StepFRQ( & ); //Set_PWM_FrqDepend.......ersetzt durch extra aufruf......................
	TIMSK |= _BV(OCIE1A );	//sbi(TIMSK,OCIE1A );	//Interrupt ein
	TCCR1B = TCCR1B_CTC_MODE | TCCR1B_CLOCKSEL_CPU_1024;//Clear Timer on Compare=CTC.  MODE an OCR1A + / CLk/1024
//1.Write High	
//	timer_enable_int(_BV(OCIE1A));	//WARNUNG TIMSK wird BERSCHRIeBEN
	}
else
	{
	// TCCR1B = TCCR1B_CLOCKSEL_STOP; schon obne erledigt...
	TIMSK &= ~_BV(OCIE1A );  //cbi(TIMSK, OCIE1A); //Interrupt OFF
	};
SREG = ucSreg;
sei();
};
#endif



//MOPD
#if STEPMOTOR_USED == 1
// *******************************************************************
void SM_Run_Puls_DIR(uint32_t uiPuls, uint8_t ucDir)
// *******************************************************************
{
SetMotorDirection( ucDir );
gsStMPar.ulSM_ToRunCnt = uiPuls;
gsStMPar.ucStepMConditionFlag |= STEPM_PULSE_MODE_FLAG;
StepMotorOn();
};
#endif


















// *******************************************************************
int CheckTextNumToInt(uint8_t* pcStr, uint32_t *pulVal)
// *******************************************************************
{
uint8_t ucPars;
//"ABC,123" = Command mit Wert						//"1234"
for(ucPars=0; ucPars < strlen(pcStr); ucPars++ )//Check ob alles eine TEXTNUMMER IST
	{
	if( !(isalnum( *(pcStr + ucPars) )) )
		{
#if MSG_SUPPRESS_DIRECTIVE == 0
		Print_PStrCRLF( MCA_WRONG_MSG );
#endif
		return (*pulVal = 0);	//Setze 0 ein, falls kein WERT da ist...
		//FERTIG, FEHLER
		};
	};
return (*pulVal = atol(pcStr));// Und dann TO INT
};




// *******************************************************************
void CheckOrder(uint8_t *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER_MSG); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};
//Sende was erhalten...	
/*

uart_puts_p(MCA_SPACE_MSG);
//PrintStrCRLF(gsCmd.ucaCmd);
uart_puts(gsCmd.ucaCmd);
uart_puts_p(MCA_SPACE_MSG);
FloatToNumStr(gsCmd.fCmdVal_1);
uart_puts(gcaNumStr);
uart_puts_p(MCA_SPACE_MSG);
PrintFloatCRLF(gsCmd.fCmdVal_2);
*/
//========================================================================================


if( !strcasecmp_P( gsCmd.ucaCmd, MCA_PING_CMD)  )    //ping
	{
	
	Print_PStrCRLF( MCA_PONG_MSG );
	};


# if EEPROM_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SAVE_CMD) )
	{
	SaveParameter();
	};


if( !strcasecmp_P( gsCmd.ucaCmd, MCA_LOAD_CMD) ) 
	{
	LoadParameter();
	};
#endif	



#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_MOTOR_ON_CMD)  ) 
	{
	gsStMPar.ucStepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG; //Kein Pulscount
	if((uint8_t)gsCmd.fCmdVal_1)	//OPTIONAL; GLEICH MIT pULScountangabe
		{
		gsStMPar.fStepMot_FRQ = gsCmd.fCmdVal_1;		
		};	
	StepMotorOn();
	};
#endif

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_MOPD_CMD)  ) //MOTOr ON Pulse, Direction
	{
	SM_Run_Puls_DIR( (uint32_t)gsCmd.fCmdVal_1, (uint8_t)gsCmd.fCmdVal_2 );	//Default ist 200...
	};
#endif

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_MOTOR_OFF_CMD)  )
	{
	StepMotorOff();
	};
#endif

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_MOTOR_STOP_CMD)  )
	{
	StepMotorStop();
	};
#endif

#if STEPMOTOR_USED == 1

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SETFRQ_CMD) )    //TESTS
   {
	gsStMPar.fStepMot_FRQ = gsCmd.fCmdVal_1;
	Set_StepFRQ(&gsStMPar.fStepMot_FRQ);
	};
#endif

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SET_DIRECTION_CMD ) )    //TESTS
   {
	if((uint8_t)gsCmd.fCmdVal_1)
		{
		SetMotorDirection( SM_DIR_LINKS );
		}
	else
		{
		SetMotorDirection( SM_DIR_RECHTS );
		};
	};
#endif

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SET_RAMPE_CMD) )
   {
	if( (uint8_t)gsCmd.fCmdVal_1 )
		{
		gsStMPar.ucStepMot_RampRise = ((uint8_t)gsCmd.fCmdVal_1);
		gsStMPar.ucStepMConditionFlag |= STEPM_RAMPE_FLAG;		//Setze bits
		}
	else
		{
		gsStMPar.ucStepMConditionFlag &= ~STEPM_RAMPE_FLAG;		//Setze bits
		};
	};
#endif

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SET_HALFSTEPMODE_CMD) )
	{	
	Set_StepMotor_Mode( MODE_HALFSTEP );
	};
#endif
	
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SET_FULLSTEPMODE_CMD) )
	{
	Set_StepMotor_Mode(  MODE_FULLSTEP );	
	};
#endif

#if STEPMOTOR_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SPR_CMD)  ) //Set Steps per Rotation
	{	//Default ist 200...
	gsStMPar.uiSM_MotorStepsRotationType = (uint16_t)gsCmd.fCmdVal_1; //Normal 200
	};
#endif

#if ADC_USED_ENABLED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_ADC_CMD)  )    //ADC,0..7
	{	
	uart_puts_p( MCA_ADC_CMD );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintLongCRLF( ADC_10Bit( gsCmd.fCmdVal_1 ) );
	};
#endif

 #if ENDODER_CMD_ECHO_ENABLED == 1
 Print_PStrCRLF( MCA_OK_MSG );   
//PrintStrCRLF(gsCmd.ucaCmd);   
#endif
 };

// *******************************************************************
int main(void)
// *******************************************************************
{
//static uint16_t uiNN;
static uint32_t ullNow;
static unsigned int uBitPosNr;
//uint32_t ulTimeCompare; //Schneller millisekunden zeitvergleich;
//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRB = PORTB_OUTMASK;
PORTB = PORTB_PRESET_PULLMASK;

#if STEPMOTOR_USED == 1
DDRC = STEPAMP_ALLCTRL_MASK;
#else
DDRC = PORTC_OUTMASK;
#endif
PORTC = PORTC_PRESET_PULLMASK;

DDRD = PORTD_OUTMASK;	
PORTD = PORTD_PRESET_PULLMASK;

//INTERRUPT MODE EiNSTELLEMN;

//GATE_INT1_OFF_MAC;	//Ausschalten damit klare Bedingungen sind
//OVERFLOW_CNT_OFF_INT0_MAC;
#if TIMERX_USED == 1
Timer_Init();
#endif
#if TIMER2_USED == 1
StartTimer2();	//8 Bit Timer 2 = MS Tick Counter
#endif

// ZUM LESEN IMMER PINx verwenden
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
//The global interrupt flag is maintained in the I bit of the status register (SREG).
ACSR |= ACD| ACBG; // + BANDGAP

/*
cbi(ACSR, ACIE);	//Analog Comaprator Interrupt dissable
cbi(ACSR, ACI);		//Analog Comaprator Interrupt FLAG dissable
sbi(ACSR, ACD);  	//Analog Comparator PWR Disable 
*/

#if UART_USE_ENABLED == 1
ResetRxBuff();
      // Initialize UART library, pass baudrate and avr cpu clock
     //  with the macro UART_BAUD_SELECT()
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
sei();
#endif

//LCD...
#if LCD_4Bit_Module_USED == 1
lcd_init(LCD_DISP_ON);
 /* clear display and home cursor */
lcd_clrscr();
_delay_ms( LCD_STARTDELAY_MS );
#endif 


#if STEPMOTOR_USED == 1
//SET ALL PREDEFS BEFORE READING EEPROM
gsStMPar.fStepMot_FRQ = PREDEF_STEPFREQUENZ;		//Default 100.0
gsStMPar.ucSM_Mode = PREDDEF_STEPMODE;				//MODE_HALFSTEP
gsStMPar.fRampeFrq = PREDEF_RAMPENSSTARTFRQ; 	//10.0 
gsStMPar.ucStepMot_RampRise = PREDEF_RAMP_RISE;	//Default 0
//gsStMPar.ulMotorRunTime = PREDEF_MOTOR_RUN_TIME; //0xFFFFFFFF = Allways
gsStMPar.ulSM_ToRunCnt = PREDEF_STEPRCLOCKS;//= 1 wieviele Steps soll der Motor gehen(Default= 1)
gsStMPar.uiSM_MotorStepsRotationType = PREFDEF_STEPS_PER_ROTATION;	//Default 400
#endif 


//VERIY IMPORTANT....
//BEI FEHLER (EEPROM UNBESCHRIEBEN ; LADE WERTE
if( CheckEEPROM_Valid() )//return 0 = WRONG
	{
	LoadParameter();	//EEprom VALID CHECK INCLUDED !!!
	}
else
	{
	SaveParameter();
	};
// ************ MAIN LOOP FOR EVER *********************
// ************ MAIN LOOP FOR EVER *********************
ullNow = gulT2_Ticks = uBitPosNr = 0;
PrintStrCRLF("Hallo");

for (;;)  /* loop forever */
   {	
	sei();
//	PORTC = gulT2_Ticks;
//@@main
	wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	if( GetTickDifference(ullNow) > PULS_PER_SECOND_T2 )
		{
		ullNow = gulT2_Ticks; 
		PORTD = (1 << uBitPosNr) ;
		uBitPosNr++;
		uBitPosNr %= 8; 		
		};	

#if UART_USE_ENABLED ==1
	UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
	}; // main   END END *************
};
// ******************* MAIN END ********************************************



/*
#if USE_ERROR_FLAG == 1
// ****************************************************************
uint8_t CheckTimeOut(uint32_t ulTimeNow, uint32_t uiCDiffTime )
// ****************************************************************
{ // OK = 1 weil && praktisch
if( GetTickDifference(ulTimeNow) < uiCDiffTime  )
	{
	gbErrorFlag &= ~TIME_OUT_ErrorFlag;
	CLR_TIMEOUT_SIGN_MAC;
	return 1;
	}
else
	{
	gbErrorFlag |= TIME_OUT_ErrorFlag;
	SET_TIMEOUT_SIGN_MAC;
	return 0;
	};
};
#endif
*/
